SLASH_ELGOH1, SLASH_ELGOH2 = "/elgoh", "/lgoh";
SlashCmdList["ELGOH"] = function(msg, editBox)
	msg = string.lower(msg);
	if(msg=="flask" or msg=="cauld" or msg=="cauldron") then
		Cauld_UpdateList(true);
	elseif(msg=="options" or msg=="config") then
		InterfaceOptionsFrame_OpenToCategory("Elgoh");
	elseif(msg=="auto") then
		Elgoh_AutoRaid();
	elseif(msg=="clean") then
		Elgoh_CleanGuild();
	elseif(msg=="clean now") then
		Elgoh_CleanGuild(true);
	elseif(string.find(msg,"top")) then
		local topnum=string.match(msg,"%d+");
		local where=string.match(msg,"raid") or string.match(msg,"guild") or string.match(msg,"officer") or string.match(msg,"party");
		if(topnum==nil) then topnum=5; end
		ElPrint("The top "..topnum.." priorities are:",where);
		local Guildies={};
		for i = 1, GetNumGuildMembers(), 1 do 
			Guildies[i] = GetGuildRosterInfo(i);
		end
		table.sort(Guildies, Elgoh_SortLooters);
		local you=false;
		topnum=tonumber(topnum);
		for i=1,#Guildies,1 do
			if(Guildies[i]==UnitName("PLAYER")) then Guildies[i]=Guildies[i].." (me)"; you=true; end
			if(i<=topnum) then
				ElPrint(i..") "..Guildies[i],where);
			elseif(i>topnum and Guildies[i]==UnitName("PLAYER")) then
				ElPrint(i..") "..Guildies[i],where);
			end
		end
		return;
	elseif(msg=="start") then
		if(CanEditOfficerNote()~=1) then return; end
		Elgoh_StartDKP();
	elseif(msg=="import") then
		if(CanEditOfficerNote()~=1) then return; end
		for i=1, GetNumGuildMembers(), 1 do 
			local name = GetGuildRosterInfo(i);
			EDB_LoadValues(name);
		end
		SendChatMessage(GetGuildInfo("player")..": EPGP has been imported", "OFFICER")
	else
		ElPrint("Available Commands:");
		ElPrint("top <number> - Displays a list of the top <number> priorities in your guild (Prints to Raid if you're in one, or to yourself otherwise)");
		ElPrint("import - Loads all values contained in the website export file (Irreversible; Make sure you're sure you wish to do this)(Requires Officer)");
		ElPrint("start - Generates a list of people in the same zone as you (for import into Guildlaunch) (Requires Officer)");
		ElPrint("clean - Removes stale guild members (Requires Officer)");
		ElPrint("auto - Applies assist, roles and master looter (Requires Raid Leader)");
		ElPrint("top <number> <where> - Prints a list of the top <number> priorities");
		ElPrint("options or config- Opens the options menu to configure Elgoh");
    end
end

SLASH_ANOO1 = "/anoo"
SlashCmdList["ANOO"] = function(msg, editBox)
	msg = strlower(msg);
	if(msg=="version") then
		SendAddonMessage("anoo", "version", "GUILD");
	else
		ReloadUI();
	end
end

SLASH_DISBAND1 = "/disband"
SlashCmdList["DISBAND"] = function(msg, editBox)
	for i=GetNumGroupMembers(), 0, -1 do 
		name = GetRaidRosterInfo(i); -- 2=RL, 1=Assist, 0=raider
		if(name~=UnitName("player")) then UninviteUnit(name); end
	end
end

SLASH_READYCHECK1 = "/rc"
SlashCmdList["RC"] = function(msg, editBox)
	DoReadyCheck();
end

SLASH_LGOHB1 = "/breaktime"
SlashCmdList["LGOHB"] = function(msg, editBox)
local Time=msg;
	if(Time=="") then  Time=10; end
	if(IsAddOnLoaded("DBM-Core")) then	
		SendChatMessage(string.gsub(ElgohSettings["BreaktimeString"], "TIME", Time), "RAID")
		DBM:CreatePizzaTimer(60*Time, "Breaktime", 1, "the Officers")
	else
		ElPrint("Timers require Deadly Boss Mods");
	end
end

function Elgoh_AllowToMove(frame)
	frame:EnableMouse(true)
	frame:SetMovable(true);
	frame:SetClampedToScreen(true);
	frame:RegisterForDrag("LeftButton");
	frame:SetScript("OnDragStart", frame.StartMoving);
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing);
end

function Elgoh_DKPWhisper(who)
	EDB_Snapshot(who);
	if (EDB[who]~=nil) then
		SendChatMessage("Detailed Results for "..who..":", "WHISPER", nil, who);
		SendChatMessage("EP: "..EDB[who]["earned"], "WHISPER", nil, who);
		SendChatMessage("GP: "..EDB[who]["spent"], "WHISPER", nil, who);
		SendChatMessage("Priority: "..EDB[who].priority, "WHISPER", nil, who);
	else
		SendChatMessage("No DKP exists for "..who, "WHISPER", nil, who);
	end		
end

function Elgoh_Print(...)
	message=strjoin(" ", tostringall(...));
	message="|cff66ff33Elgoh:|r "..message;
	print(message);
end

function ElPrint(message,where)
	--local message=strjoin(" ", tostringall(...));
	if(where==nil) then 
		message="|cff66ff33Elgoh:|r "..message;
		print(message);
	else
		SendChatMessage(message, where);
	end
end

-- function EDebug(message)
	-- if(ElgohSettings["Debug"]==1 and message~=nil) then
		-- message="|cff119900Elgoh:|r "..message;
		-- print(message);
	-- end
-- end

function EDebug(...)
	message=strjoin(" ", tostringall(...));
	if(ElgohSettings["Debug"]==1 and message~=nil) then
		message="|cff119900Elgoh:|r "..message;
		print(message);
	end
end