ElgohHistory={};
EDB={};
InterestedRaiders={};
ElgohLooters={};
ElgohPromote={};
ElgohRolling=0;
ElgohCurrentItem="";

local frame = CreateFrame("Frame")

function Elgoh_AutoRaid()
	if(UnitIsGroupAssistant("PLAYER") or UnitIsGroupLeader("PLAYER")) then
		for i=1, GetNumGroupMembers(), 1 do 
			local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
			_, guildRankName = GetGuildInfo(name);
			if(ElgohPromote[guildRankName]==1 or isML or role=="MAINTANK" or role=="MAINASSIST") then 
				PromoteToAssistant(name,1); 
			end
		end
		if(GetLootMethod()~="master") then
			SetLootMethod("master", UnitName("PLAYER"));
		end
	end
end

local upgrade_warned = false;
function Elgoh_OnEvent(self,event, ...)
	if(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;		
		if(prefix=="anoo") then
			if(msg=="version") then
				SendAddonMessage("anoo", ElgohVers, "WHISPER", who);	
			else
				EDebug(who.." has "..msg);
				if(tonumber(msg)>(tonumber(ElgohVers)) and not upgrade_warned) then 
					ElPrint("There may be an updated version available from:\nhttp://wow.curse.com/downloads/wow-addons/details/elgoh.aspx"); 
					upgrade_warned=true; 
				end
			end
		elseif(prefix=="elgoh") then
			if(CanEditOfficerNote()==1 and msg:find("^!")~=nil) then
				EDebug("Being Queried for "..string.sub(msg,2).."...");
				for i = 1, GetNumGuildMembers(), 1 do
					local name,_,_,_,_,_,_,officernote = GetGuildRosterInfo(i);
					if(name==string.sub(msg,2)) then
						local EDBString=string.match(officernote, "$(.*)%$");
						SendAddonMessage("elgoh", "$"..name.."$"..EDBString, "WHISPER", who);
						EDebug("Sending $"..name.."$"..EDBString);
					end
				end
			elseif(CanEditOfficerNote()~=1 and string.find(msg,"^%$")~=nil) then
				EDebug("Officer Reply...");
				ElgohWaitingOnOfficer=false;
				who=msg:match("^$(.*)%$");
				msg=string.sub(msg,who:len()+3);
				EDebug(msg);
				local Earned,Spent,Priority=strsplit(":",msg);
				Earned=tonumber(Earned);
				Spent=tonumber(Spent);
				Priority=tonumber(Priority);
				
				EDB[who]={};
				EDB[who]["earned"]=Earned;
				EDB[who]["spent"]=Spent;
				EDB[who]["priority"]=Priority;
				EDB_UpdateLines(EDB.selected);
			end
		end
	elseif(event=="CHAT_MSG_SYSTEM") then
		local message=...; if(message:find("rolls %d+"))==nil then return; end
		local name=strmatch(message, "^(%a+) ");
		--EDebug(name.." rolled!");
		Elgoh_RaiderInterested(name);
	elseif(event=="CHAT_MSG_RAID_WARNING") then
		if(ElgohRolling==1) then return; end
		for i=1, GetNumGroupMembers(), 1 do 
			local name, rank,_,_,_,_,_,_,_, role, isML = GetRaidRosterInfo(i);
			if(name==UnitName("PLAYER") and (isML or ElgohSettings.Debug==1)) then
				local message,who=...; if(message:find("|h%["))==nil then EDebug("No itemLink"); return; end
				local item=string.match(message, "(%[.+%])");
				EDebug("Item: "..item);
				LootingReset();
				ElgohRolling=1;
				ElgohCurrentItem=message:match("(|cff.+|r)");
				Elgoh_RefreshLootList();
				return;
			end
		end
	elseif(event=="CHAT_MSG_WHISPER") then
		local message,who=...; if(message:find("^!dkp")==nil and message:find("^!dpl")==nil) then return; end
		if(message:find("^!dpl")) then SendChatMessage("I just did "..math.random(9001).." dpl!", "WHISPER", nil, who); return; end
		Elgoh_DKPWhisper(who);
	elseif(event=="LOOT_OPENED" or event=="LOOT_SLOT_CLEARED" or event=="LOOT_SLOT_CHANGED" or event=="LOOT_CLOSED") then
		if(ElgohSettings.Debug==1) then Elgoh_LootShow(); end
		if(GetNumGroupMembers()==0) then return; end
		Elgoh_LootShow();
	end
end

function Elgoh_CleanGuild(Remove)
	local kick=0;
	local showoffline=0;
	local _, _, selfIndex = GetGuildInfo("PLAYER");
	if(GuildRosterShowOfflineButton~=nil) then
		showoffline=GuildRosterShowOfflineButton:GetChecked();
	end
	SetGuildRosterShowOffline(true);
	for i = 1, GetNumGuildMembers(), 1 do 
		local _, monthsOffline, daysOffline = GetGuildRosterLastOnline(i);
		local name, _, rankIndex, level, _, _, note, _, online = GetGuildRosterInfo(i);
		EDebug(name,level,online,daysOffline,monthsOffline);
		if(online==nil and ((daysOffline>20 and level<=40) or (daysOffline>=29 or monthsOffline>0)) and selfIndex<rankIndex and note:find("~")==nil) then 
			if Remove then 
				ElPrint("Kicking "..name)
				GuildUninvite(name); 
			else
				ElPrint(name.." ("..level..") will be removed")
			end
			kick=kick+1;
		end
	end
	SetGuildRosterShowOffline(showoffline);
	if(kick==0) then ElPrint("No inactive players"); else 
		if(kick==1) then
			ElPrint("Type '/lgoh clean now' to remove"); 
		else
			ElPrint("Type '/lgoh clean now' to remove "..kick.." people"); 
		end
	end
end

ElgohSettings_Default={
	["EPGPValues"]=1,
	["EPGPThreshhold"]=750,
	["Debug"]=0,
	["OSDiscount"]=0.5,
	["MiniLvl"]=476,
	["BreaktimeString"]="Breaktime! Be back in TIME minutes!",
	["MSString"]="Roll for ITEM Mainspec",
	["OSString"]="Roll for ITEM Offspec",
	["StartBonus"]=50,
	["Symbiosis"]=1,
}

function Elgoh_Loaded(self, event, addon)
	if (event == "ADDON_LOADED" and addon:lower()=="elgoh") then
		frame:RegisterEvent("CHAT_MSG_ADDON");
		frame:RegisterEvent("CHAT_MSG_WHISPER");
		frame:RegisterEvent("LOOT_OPENED");
		frame:RegisterEvent("LOOT_SLOT_CLEARED");
		frame:RegisterEvent("LOOT_SLOT_CHANGED");
		frame:RegisterEvent("LOOT_CLOSED");
		frame:RegisterEvent("CHAT_MSG_RAID_WARNING");
		frame:RegisterEvent("CHAT_MSG_SYSTEM");
		
		RegisterAddonMessagePrefix("elgoh");
		RegisterAddonMessagePrefix("anoo");
		
		Elgoh_HookTooltips();
		Elgoh_AddDropdowns();
		
		LootFrameDownButton:HookScript("OnClick", Elgoh_LootShow);
		LootFrameUpButton:HookScript("OnClick", Elgoh_LootShow);
		
		if(ElgohSettings==nil or #ElgohSettings~=#ElgohSettings_Default) then 
			if(ElgohSettings==nil) then
				ElPrint("Applying default settings...)");
			else
				ElPrint("Old settings found, applying new defaults...");
			end
			ElgohSettings=ElgohSettings_Default;
		end
	elseif(event=="PLAYER_LOGIN") then
		frame:SetScript("OnEvent", Elgoh_OnEvent);
		ElgohVers=GetAddOnMetadata("Elgoh", "X-Curse-Packaged-Version")
		if(ElgohVers==nil) then ElgohVers="r1"; end --it's NIL if using the working copy
		ElgohVers = string.sub(ElgohVers, 2); --gets rid of the r
		
		SendAddonMessage("anoo", ElgohVers, "GUILD"); --Addon update check for if they have an older copy
		SendAddonMessage("anoo", "version", "GUILD"); --Addon update check for if YOU have an older copy
		
		ElPrint("Version "..ElgohVers.." has been loaded");
	end
end

function EditLoot()
	LootFrame:SetWidth(500);
	LootFrame:SetBackdrop(nil);
	LootFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
												edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
												tile = true, tileSize = 16, edgeSize = 16, 
												insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	--LootFrame:SetBackdropColor(0,0,0,1);
end

frame:RegisterEvent("ADDON_LOADED");
frame:RegisterEvent("PLAYER_LOGIN");
frame:SetScript("OnEvent", Elgoh_Loaded);