function Elgoh_HookTooltips()
	for _, tooltip in ipairs(ElgohTooltipList) do
		if tooltip then
			for _, tooltipType in ipairs(ElgohTooltipMethodList) do
				hooksecurefunc(tooltip, tooltipType, ElgohTooltip)
			end
		end
	end
	--hooksecurefunc(GameTooltip, "SetUnit", ElgohModTooltip);
	GameTooltip:HookScript("OnTooltipSetUnit", ElgohModTooltip); 
end

ElgohTooltipList = {
	ItemRefTooltip,
	GameTooltip,
	ShoppingTooltip1,
	ShoppingTooltip2,
	ComparisonTooltip1,
	ComparisonTooltip2,
}

ElgohTooltipMethodList = {
	"SetHyperlink", 
	"SetBagItem",
	"SetInventoryItem",
	"SetAuctionItem",
	"SetAuctionSellItem",
	"SetLootItem",
	"SetLootRollItem",
	"SetTradeSkillItem",
	"SetTrainerService",
	"SetInboxItem",
	"SetSendMailItem",
	"SetQuestItem",
	"SetQuestLogItem",
	"SetTradePlayerItem",
	"SetTradeTargetItem",
	"SetMerchantItem",
	"SetHyperlinkCompareItem",
	"SetBuybackItem",
}

ElgohSymGet={
	{ --Moon
		"122292","110698","110588","110788","110707","110570","110802","110621","122291","126458"},
	{ --Cat
		"112997","110700","110597","110730","110715","122282","110807","110693","110810","126449"},
	{ --Bear
		"113002","110701","110600","122289","110717","122285","110803","110694","122290","126453"},
	{ --Tree
		"113004","122288","110617","110791","110718","110575","110806","110696","112970","126456"},
}
	
ElgohSymGive={
	{ --DAMAGER
		"122294","122287","113073","113613","113277","113516","113286","113074","113295","127361"},
	{ --TANK
		"122294","113269","","","","113516","","","","127361"},
	{ --HEALER
		"","113269","","","113506","","113289","","","113275"},
}

ElgohSymGetKey={"Balance","Feral","Guardian","Restoration"};
ElgohSymGiveKey={"Damager","Tank","Healer"};

function ElgohModTooltip(tooltip)
	local person,unit=tooltip:GetUnit();	
	if(not UnitIsPlayer(unit)) then return; end

	local ClassID=select(3,UnitClass(unit));
	local ClassIDcolour=select(2,UnitClass(unit));
	local MyID=select(3,UnitClass("PLAYER"));
	local MyIDcolour=select(3,UnitClass("PLAYER"));
	local Spec=GetSpecialization();
	local TheirSpec="";
	
	if(person==ElgohDisenchanter) then 
		tooltip:AddLine("Disenchanter", 0.2,1,0.2);
	end
	if(ElgohSettings.Symbiosis==1 and Spec~=nil) then
		if(MyID==11 and ClassID~=11) then --Druid on Druid action right here
			tooltip:AddLine(" ");
			if(not IsAltKeyDown()) then
				tooltip:AddDoubleLine("You get:",GetSpellInfo(ElgohSymGet[Spec][ClassID]),RAID_CLASS_COLORS.DRUID.r,RAID_CLASS_COLORS.DRUID.g,RAID_CLASS_COLORS.DRUID.b,RAID_CLASS_COLORS[ClassIDcolour].r,RAID_CLASS_COLORS[ClassIDcolour].g,RAID_CLASS_COLORS[ClassIDcolour].b);
			else
				tooltip:AddSpellByID(ElgohSymGet[Spec][ClassID]);
			end
		elseif(MyID~=11 and ClassID==11) then --Non Druid vs Druid
			if(not IsAltKeyDown()) then
				tooltip:AddDoubleLine("You get:",GetSpellInfo(ElgohSymGive[GetSpecializationRole(Spec)][MyID]),RAID_CLASS_COLORS[MyIDcolour].r,RAID_CLASS_COLORS[MyIDcolour].g,RAID_CLASS_COLORS[MyIDcolour].b,RAID_CLASS_COLORS.DRUID.r,RAID_CLASS_COLORS.DRUID.g,RAID_CLASS_COLORS.DRUID.b);
			else
				tooltip:AddSpellByID(ElgohSymGive[GetSpecializationRole(Spec)][MyID]);
			end
		end
		
		if(MyID==11 and ClassID~=11) then -- Show THEIR Spell
			for i=1,3,1 do
				if(ElgohSymGive[i][ClassID]~="") then 
					tooltip:AddDoubleLine(ElgohSymGiveKey[i]..":",GetSpellInfo(ElgohSymGive[i][ClassID]),RAID_CLASS_COLORS[ClassIDcolour].r,RAID_CLASS_COLORS[ClassIDcolour].g,RAID_CLASS_COLORS[ClassIDcolour].b,RAID_CLASS_COLORS.DRUID.r,RAID_CLASS_COLORS.DRUID.g,RAID_CLASS_COLORS.DRUID.b);
				end
			end	
			--tooltip:AddSpellByID(ElgohSymGive[GetSpecializationRole(Spec)][MyID]);
		elseif(MyID~=11 and ClassID==11) then
			for i=1,4,1 do
				if(ElgohSymGet[i][ClassID]~="") then 
					tooltip:AddDoubleLine(ElgohSymGetKey[i]..":",GetSpellInfo(ElgohSymGet[i][ClassID]),RAID_CLASS_COLORS.DRUID.r,RAID_CLASS_COLORS.DRUID.g,RAID_CLASS_COLORS.DRUID.b,RAID_CLASS_COLORS[ClassIDcolour].r,RAID_CLASS_COLORS[ClassIDcolour].g,RAID_CLASS_COLORS[ClassIDcolour].b);
				end
			end	
			--tooltip:AddSpellByID(ElgohSymGet[GetSpecializationRole(Spec)][MyID]);
		end
	end		
	tooltip:Show();
end

function ElgohTooltip(tooltip, a, b)
	if(ElgohSettings["EPGPValues"]~=1) then return; end
	_,item = tooltip:GetItem()
	itemLevel,itemCost = ElgohiLvl(item)
	if(itemLevel<ElgohSettings["MiniLvl"]) then return false; end
	
	ms_price=itemCost;
	os_price=itemCost*ElgohSettings.OSDiscount
	tooltip:AddDoubleLine("Mainspec price: ", ms_price, 0.7, 0.3, 1.0, 0.8, 0.8, 0.8);
	tooltip:AddDoubleLine("Offspec price: ", os_price, 0.7, 0.3, 1.0, 0.8, 0.8, 0.8);
	tooltip:Show();
end

function ElgohiLvl(item)
	if not item then return -1000,0; end
	name,_,itemRarity,itemLevel,_,itemType,itemSubType,_,itemEquipLoc = GetItemInfo(item)
	if(itemLevel==nil) then return 0; end
	dkp_base = (itemLevel - 1.3) / 1.3
	
	-- Tokens
	if(name:find("of the")~=nil and (name:find("Protector")~=nil or name:find("Vanquisher")~=nil or name:find("Conqueror")~=nil)) then
		if(name:find("Chest")~=nil) then
			itemEquipLoc="INVTYPE_CHEST";
		elseif(name:find("Mantle")~=nil or name:find("Shoulder")~=nil) then
			itemEquipLoc="INVTYPE_SHOULDER"
		elseif(name:find("Gauntlets")~=nil or name:find("Gloves")~=nil) then
			itemEquipLoc="INVTYPE_HAND"
		elseif(name:find("Helm")~=nil or name:find("Crown")~=nil) then
			itemEquipLoc="INVTYPE_HEAD"
		elseif(name:find("Leg")~=nil) then
			itemEquipLoc="INVTYPE_LEGS"
		end
	end
	
	-- Set slot modifier
	dkp_slot = 0
	if     (itemEquipLoc == "INVTYPE_HEAD") then
		dkp_slot = 1
	elseif (itemEquipLoc == "INVTYPE_NECK") then
		dkp_slot =  0.54
	elseif (itemEquipLoc == "INVTYPE_SHOULDER") then
		dkp_slot = 0.74
	elseif (itemEquipLoc == "INVTYPE_CHEST") then
		dkp_slot = 1
	elseif (itemEquipLoc == "INVTYPE_ROBE") then
		dkp_slot = 1
	elseif (itemEquipLoc == "INVTYPE_WAIST") then
		dkp_slot = 0.74
	elseif (itemEquipLoc == "INVTYPE_LEGS") then
		dkp_slot = 1
	elseif (itemEquipLoc == "INVTYPE_FEET") then
		dkp_slot = 0.74
	elseif (itemEquipLoc == "INVTYPE_WRIST") then
		dkp_slot = 0.54
	elseif (itemEquipLoc == "INVTYPE_HAND") then
		dkp_slot = 0.74
	elseif (itemEquipLoc == "INVTYPE_FINGER") then
		dkp_slot = 0.54
	elseif (itemEquipLoc == "INVTYPE_TRINKET") then
		dkp_slot = 0.68
	elseif (itemEquipLoc == "INVTYPE_CLOAK") then
		dkp_slot = 0.54
	elseif (itemEquipLoc == "INVTYPE_WEAPON") then
		dkp_slot = 1
	elseif (itemEquipLoc == "INVTYPE_SHIELD") then
		dkp_slot = 0.65
	elseif (itemEquipLoc == "INVTYPE_2HWEAPON") then
		dkp_slot = 1.5
	elseif (itemEquipLoc == "INVTYPE_WEAPONMAINHAND") then
		dkp_slot = 1
	elseif (itemEquipLoc == "INVTYPE_WEAPONOFFHAND") then
		dkp_slot = 1
	elseif (itemEquipLoc == "INVTYPE_HOLDABLE") then
		dkp_slot = 0.52
	elseif (itemEquipLoc == "INVTYPE_RANGED" or itemEquipLoc == "INVTYPE_RANGEDRIGHT" or itemEquipLoc == "INVTYPE_THROWN") then
		if (itemSubType == "Guns" or itemSubType == "Bows" or itemSubType == "Crossbows") then
			dkp_slot = 1.5
		else
			dkp_slot = 0.50
		end
	elseif (itemEquipLoc == "INVTYPE_RELIC") then
		dkp_slot = 0.30
	else
		dkp_slot = 0
	end

	if (dkp_base == 0 or dkp_slot == 0) then 
		return -1000,0
	else
		return itemLevel,math.floor(dkp_base * dkp_slot)
	end 
end
--((itemLevel - 1.3) / 1.3) * dkp_slot